<!-- [![Build Status](https://travis-ci.org/Microsoft/TypeScript.svg?branch=master)](https://travis-ci.org/Microsoft/TypeScript)
[![npm version](https://badge.fury.io/js/typescript.svg)](https://www.npmjs.com/package/typescript)
[![Downloads](https://img.shields.io/npm/dm/typescript.svg)](https://www.npmjs.com/package/typescript) -->

# TypeScript + UI5

## What is this?

This is an *experimental* fork of TypeScript 2.7.0, where we changed ES2015 and module transpilers to generate javascript code that can work with UI5.

## Why not using ui5ts?

When creating new UI5 to be launched from within Fiori launchpad, you probably won't be able to modify or add new .js in your index.html

That is why we created a fork that ensures the transpiled javascript files works as UI5 modules.

Also, if by any change you get tired for TypeScript you can just continue from the generated JS files.

## Contribute


We are always looking for help. You can:
* [Submit bugs](https://github.wdf.sap.corp/TypeScriptUI5/TypeScriptUI5/issues).
* Review the [source code changes](https://github.wdf.sap.corp/TypeScriptUI5/TypeScriptUI5/pulls).
* Contribute with bug fixes or design proposals.

## What to learn more about TypeScript?

*  [Quick tutorial](https://www.typescriptlang.org/docs/tutorial.html)
*  [TypeScript repository](https://github.com/Microsoft/TypeScript)
*  [TypeScript Homepage](https://www.typescriptlang.org/)

## Building

Same thing as TypeScript default build, in case you have not checked the TypeScript repository:

Ensure that you have [Git](https://git-scm.com/downloads) and [Node.js](https://nodejs.org/) installed.

Clone a copy of the repo:

```bash
git clone https://github.wdf.sap.corp/TypeScriptUI5/TypeScriptUI5.git
```

Change to the TypeScript directory:

```bash
cd TypeScript
```

Install Gulp tools and dev dependencies:

```bash
npm install -g gulp
npm install
```

Use one of the following to build and test:

```
gulp local            # Build the compiler into built/local 
gulp clean            # Delete the built compiler 
gulp LKG              # Replace the last known good with the built one.
                      # Bootstrapping step to be executed when the built compiler reaches a stable state.
gulp tests            # Build the test infrastructure using the built compiler. 
gulp runtests         # Run tests using the built compiler and test infrastructure. 
                      # You can override the host or specify a test for this command. 
                      # Use host=<hostName> or tests=<testPath>. 
gulp runtests-browser # Runs the tests using the built run.js file. Syntax is gulp runtests. Optional
                        parameters 'host=', 'tests=[regex], reporter=[list|spec|json|<more>]'.
gulp baseline-accept  # This replaces the baseline test results with the results obtained from gulp runtests.
gulp lint             # Runs tslint on the TypeScript source.
gulp help             # List the above commands. 
```


## Usage

```bash
node built/local/tsc.js hello.ts
```


